## Script (Python) "newdatafile"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
from Products.eCampaigning import ProductMessageFactory as _

#DECODERS = ("ascii","iso8859-1","cp1252")
DECODERS = None

# encode export (to enable, set value to say, UTF-8, instead of None)
# note that encodings are not available on plone 2.0.x (so must be set to None)(???)
ENCODING = "utf-8"

textmarker = '"'
separator = ','
replacechar = "'"
escapechar = None

# The filename is generated from GMT timezone
zone = "GMT"
dt = DateTime()
n = context.getName().replace(' ', '_')
nameparts = (n, dt.yy(), dt.mm(), dt.dd())
filename = '_'.join(nameparts) + ".csv"

fields = ("datetime", "user_agent_language", "givenname","familyname","emailaddress",
           "country","receive_updates","streetaddress","postalcode","city","name_df",
           "origin_url","entry_url","onsite_origin_url","origin_id","origin_person_id",
           "origin_version_id", "origin_segment_id","origin_keywords",
           "messagesubject","message"
         )

# Add header row
line = []
for f in fields:
   headertranslation = context.translate(_("header_dataexport_record_"+f))
   line.append("%s%s%s" % (textmarker, headertranslation, textmarker))
headers = separator.join(line)

headers = headers.encode(ENCODING)

# build the sample batch used to approximate download size
sample = []
sample_count = 1

record_count = context.getRecordCount()

if record_count == 0:
   psm = _("dataexport_error_no_data")
   context.REQUEST.RESPONSE.redirect("view?portal_status_message=%s" % psm)
   return

if record_count < sample_count:
   sample_count = record_count

records = context.getRecords()

for i,r in enumerate(records):
   rdata = r.aq_inner.getFieldsAsText(
              fields,
              separator=separator,
              textmarker=textmarker,
              replacechar=replacechar,
              escchar=escapechar,
              decoders=DECODERS
   )
   sample.append(rdata)
   if i >= sample_count:
      break

# Estimate the size of the download

samplestring = "\n".join(sample).encode(ENCODING)

avg_record = len(samplestring) * 1.0 / sample_count * 1.0
avg_record += avg_record * 0.1
download_size_guess = len(headers) + int(avg_record * record_count)


# the RESPONSE
RESPONSE = context.REQUEST["RESPONSE"]
RESPONSE.setHeader('Cache-Control', "max-age=0,no-cache,no-store")
RESPONSE.setHeader('Content-type', 'application/vnd.ms-excel;charset="%s"' % ENCODING)
RESPONSE.setHeader('Content-disposition','attachment;size=%s;filename=%s' % (download_size_guess,filename))
RESPONSE.setHeader('Content-length', download_size_guess)

# Write the CSV headers and the sample
first_batch = "\n".join((headers,samplestring,''))
RESPONSE.write(first_batch)

del headers
del samplestring

# Initialize total & linecount
total_size = len(first_batch)
linecount = 0

# Write the rest of the records, if any
if sample_count < record_count:
   for r in records:
      dataline = r.aq_inner.getFieldsAsText(
                        fields,
                        separator=separator,
                        textmarker=textmarker,
                        replacechar=replacechar,
                        escchar=escapechar,
                        decoders=DECODERS,
      ) + "\n"

      dataline = dataline.encode(ENCODING)

      RESPONSE.write(dataline)
      total_size += len(dataline)
      linecount += 1

# Add the padding to make the browsers happy
if total_size < download_size_guess:
   RESPONSE.write(' ' * (download_size_guess - total_size))

return
