## Controller Python Script "steptask_emailtargets"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=state
##title=Email action targets
##

from Products.eCampaigning import ProductMessageFactory as _

TARGET_EMAIL_ENCODING = "utf-8"

action = context.aq_parent
recordcontainer = action.getRecordContainer()

actiontype = action.getActiontype()

record_path = context.REQUEST.SESSION['record_path']
record = context.restrictedTraverse(record_path)

supporter_email = "%s <%s>" % (record.getFullName(), record.emailaddress)
message_subject = record.getSubject()

msg_tmpl = action.getMessagetemplate()

# get stored message or from the template - no transformations at this stage!
msg = getattr(record, "message", msg_tmpl.getRawText())

# not used???
#editablemsg = action.getAction_message_modifiable()

try:
   tmpl_msgtype = msg_tmpl.getField("text").getContentType(msg_tmpl)
except AttributeError, e:
   errmsg = "Action not configured: the Action Message for this Action needs to be configured: %s" % e
   return state.set(status="failure", portal_status_message=errmsg)

thankyou_email_template = action.getThankyouemail()
try:
   thankyou_subject = thankyou_email_template.getMessagetitle()
except AttributeError, e:
   errmsg = "Action not configured: the thank-you email message for this Action needs to be configured"
   return state.set(status="failure", portal_status_message=errmsg)

# getRawText would implicitly disable data merge
thankyou_email_message = thankyou_email_template.getText()
thankyou_messagetype = thankyou_email_template.getField("text").getContentType(thankyou_email_template)
thankyou_from = action.getThankyouemailname() + " <" + action.getThankyouemailfrom() + ">"

# optionally, add a copy of the message (plaintext if thanks is plaintext)

# APPEND A COPY OF THE MESSAGE 
if context.getThankyouemail_includemessage():
   attach_msg = msg
   msgid = "label_%s_thanksemail_copydivider" % context.sanitizedTypeName(typename=actiontype)
   i18ndivider = context.translate(_(msgid), domain="ecampaigning")
   divider = "\n\n%s\n\n" % i18ndivider

   if thankyou_messagetype == "text/plain":
      attach_msg = record.getMessage(mimetype="text/plain")
      thankyou_email_message += "\n\n%s\n\n%s\n\n%s" % (divider, message_subject, attach_msg)
   elif thankyou_messagetype == "text/html":
      divider = "<br/>%s<br/>" % divider
      if tmpl_msgtype == "text/plain":
         attach_msg = "<pre>%s</pre>" % attach_msg
      thankyou_email_message += "%s\n<p><b>%s</b></p>\n%s" % (divider, message_subject, attach_msg)
   else:
      errmsg ="can just handle html and plaintext thankyou messages"
      return state.set(status="failure", portal_status_message=errmsg)

# SEND THE MESSAGE
try:
   context.MailHost.secureSend(
      thankyou_email_message,
      supporter_email,
      thankyou_from,
      subject=thankyou_subject,
      subtype=thankyou_messagetype.split('/')[1],
      charset=TARGET_EMAIL_ENCODING
   )
except Exception, e:
   errmsg = "email to %s with subject '%s' failed: %s" % (supporter_email, thankyou_subject, e)
   return state.set(status="failure", portal_status_message=errmsg)

   
return state
